#pragma once
#ifndef __MY_PASSING_VB_ARRAY_DLL_H__
#define __MY_PASSING_VB_ARRAY_DLL_H__
#include <Windows.h>
#include "TypesInfo.h"

/* byte -------------- -------------- -------------- --------------*/
EXP32 b8 * APIENTRY create_rng_byt(i32 szbuffer);
EXP32 i32 APIENTRY fill_rng_byt(b8 * buffer, i32 szbuffer);

EXP32 b8 * APIENTRY create_rng_byt_2d(i32 szbuffer1, i32 szbuffer2);
EXP32 i32 APIENTRY fill_rng_byt_2d(b8 * buffer, i32 szbuffer1, i32 szbuffer2);

EXP32 b8 * APIENTRY create_rng_byt_3d(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);
EXP32 i32 APIENTRY fill_rng_byt_3d(b8 * buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);

EXP32 b8 ** APIENTRY create_rng_byt_2dj(i32 szbuffer1, i32 szbuffer2);
EXP32 i32 APIENTRY fill_rng_byt_2dj(b8 ** buffer, i32 szbuffer1, i32 szbuffer2);

EXP32 b8 *** APIENTRY create_rng_byt_3dj(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);
EXP32 i32 APIENTRY fill_rng_byt_3dj(b8 *** buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);

/* i32 -------------- -------------- -------------- --------------*/
EXP32 i32 * APIENTRY create_rng_i32(i32 szbuffer);
EXP32 i32 APIENTRY fill_rng_i32(i32 * buffer, i32 szbuffer);

EXP32 i32 * APIENTRY create_rng_i32_2d(i32 szbuffer1, i32 szbuffer2);
EXP32 i32 APIENTRY fill_rng_i32_2d(i32 * buffer, i32 szbuffer1, i32 szbuffer2);

EXP32 i32 * APIENTRY create_rng_i32_3d(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);
EXP32 i32 APIENTRY fill_rng_i32_3d(i32 * buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);

EXP32 i32 ** APIENTRY create_rng_i32_2dj(i32 szbuffer1, i32 szbuffer2);
EXP32 i32 APIENTRY fill_rng_i32_2dj(i32 ** buffer, i32 szbuffer1, i32 szbuffer2);

EXP32 i32 *** APIENTRY create_rng_i32_3dj(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);
EXP32 i32 APIENTRY fill_rng_i32_3dj(i32 *** buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);

/* i64 -------------- -------------- -------------- --------------*/
EXP32 i64 * APIENTRY create_rng_i64(i32 szbuffer);
EXP32 i32 APIENTRY fill_rng_i64(i64 * buffer, i32 szbuffer);

EXP32 i64 * APIENTRY create_rng_i64_2d(i32 szbuffer1, i32 szbuffer2);
EXP32 i32 APIENTRY fill_rng_i64_2d(i64 * buffer, i32 szbuffer1, i32 szbuffer2);

EXP32 i64 * APIENTRY create_rng_i64_3d(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);
EXP32 i32 APIENTRY fill_rng_i64_3d(i64 * buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);

EXP32 i64 ** APIENTRY create_rng_i64_2dj(i32 szbuffer1, i32 szbuffer2);
EXP32 i32 APIENTRY fill_rng_i64_2dj(i64 ** buffer, i32 szbuffer1, i32 szbuffer2);

EXP32 i64 *** APIENTRY create_rng_i64_3dj(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);
EXP32 i32 APIENTRY fill_rng_i64_3dj(i64 *** buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);

/* double -------------- -------------- -------------- --------------*/
EXP32 double * APIENTRY create_rng_dbl(i32 szbuffer);
EXP32 i32 APIENTRY fill_rng_dbl(double * buffer, i32 szbuffer);

EXP32 double * APIENTRY create_rng_dbl_2d(i32 szbuffer1, i32 szbuffer2);
EXP32 i32 APIENTRY fill_rng_dbl_2d(double * buffer, i32 szbuffer1, i32 szbuffer2);

EXP32 double * APIENTRY create_rng_dbl_3d(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);
EXP32 i32 APIENTRY fill_rng_dbl_3d(double * buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);

EXP32 double ** APIENTRY create_rng_dbl_2dj(i32 szbuffer1, i32 szbuffer2);
EXP32 i32 APIENTRY fill_rng_dbl_2dj(double ** buffer, i32 szbuffer1, i32 szbuffer2);

EXP32 double *** APIENTRY create_rng_dbl_3dj(i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);
EXP32 i32 APIENTRY fill_rng_dbl_3dj(double *** buffer, i32 szbuffer1, i32 szbuffer2, i32 szbuffer3);

/* string -------------- -------------- -------------- --------------*/
EXP32 b8 * APIENTRY create_rng_str(i32 szbuffer);
EXP32 i32 APIENTRY fill_rng_str(b8 * buffer, i32 szbuffer);

EXP32 i32 APIENTRY fill_rng_str_list(b8 ** buffer, i32 szbuffer, const i32 *szxbuffer);
EXP32 b8 ** APIENTRY create_rng_str_list(i32 szbuffer, i32 _min, i32 _max, i32 *szxbuffer);

EXP32 void APIENTRY dispose_buffer();
#endif