﻿Option Strict On
Option Explicit On
Imports System.Runtime.InteropServices

Friend Module NativeMethodes
   Private Const DllName As String = "passingarray.dll"

   'Byte   --------------------------------------------------------------------------
   <DllImport(DllName, EntryPoint:="create_rng_byt",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngByt(sz As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_byt",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngByt(buff() As Byte, sz As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_byt_2d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngByt2d(sz1 As Int32, sz2 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_byt_2d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngByt2d(ptr As IntPtr, sz1 As Int32, sz2 As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_byt_3d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngByt3d(sz1 As Int32, sz2 As Int32, sz3 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_byt_3d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngByt3d(ptr As IntPtr, sz1 As Int32, sz2 As Int32, sz3 As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_byt_2dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngByt2dj(sz1 As Int32, sz2 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_byt_2dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngByt2dj(ptr As IntPtr, sz1 As Int32, sz2 As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_byt_3dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngByt3dj(sz1 As Int32, sz2 As Int32, sz3 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_byt_3dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngByt3dj(ptr As IntPtr, sz1 As Int32, sz2 As Int32, sz3 As Int32) As Int32
   End Function

   'Int32   -------------------------------------------------------------------------
   <DllImport(DllName, EntryPoint:="create_rng_i32",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngI32(sz As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_i32",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngI32(buff() As Int32, sz As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_i32_2d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngI322d(sz1 As Int32, sz2 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_i32_2d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngI322d(ptr As IntPtr, sz1 As Int32, sz2 As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_i32_3d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngI323d(sz1 As Int32, sz2 As Int32, sz3 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_i32_3d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngI323d(ptr As IntPtr, sz1 As Int32, sz2 As Int32, sz3 As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_i32_2dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngI322dj(sz1 As Int32, sz2 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_i32_2dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngI322dj(ptr As IntPtr, sz1 As Int32, sz2 As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_i32_3dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngI323dj(sz1 As Int32, sz2 As Int32, sz3 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_i32_3dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngI323dj(ptr As IntPtr, sz1 As Int32, sz2 As Int32, sz3 As Int32) As Int32
   End Function

   'Int64   -------------------------------------------------------------------------
   <DllImport(DllName, EntryPoint:="create_rng_i64",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngI64(sz As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_i64",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngI64(buff() As Int64, sz As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_i64_2d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngI642d(sz1 As Int32, sz2 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_i64_2d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngI642d(ptr As IntPtr, sz1 As Int32, sz2 As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_i64_3d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngI643d(sz1 As Int32, sz2 As Int32, sz3 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_i64_3d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngI643d(ptr As IntPtr, sz1 As Int32, sz2 As Int32, sz3 As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_i64_2dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngI642dj(sz1 As Int32, sz2 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_i64_2dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngI642dj(ptr As IntPtr, sz1 As Int32, sz2 As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_i64_3dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngI643dj(sz1 As Int32, sz2 As Int32, sz3 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_i64_3dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngI643dj(ptr As IntPtr, sz1 As Int32, sz2 As Int32, sz3 As Int32) As Int32
   End Function

   'Double   ------------------------------------------------------------------------
   <DllImport(DllName, EntryPoint:="create_rng_dbl",
           CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngDbl(sz As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_dbl",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngDbl(buff() As Double, sz As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_dbl_2d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngDbl2d(sz1 As Int32, sz2 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_dbl_2d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngDbl2d(ptr As IntPtr, sz1 As Int32, sz2 As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_dbl_3d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngDbl3d(sz1 As Int32, sz2 As Int32, sz3 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_dbl_3d",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngDbl3d(ptr As IntPtr, sz1 As Int32, sz2 As Int32, sz3 As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_dbl_2dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngDbl2dj(sz1 As Int32, sz2 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_dbl_2dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngDbl2dj(ptr As IntPtr, sz1 As Int32, sz2 As Int32) As Int32
   End Function

   <DllImport(DllName, EntryPoint:="create_rng_dbl_3dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngDbl3dj(sz1 As Int32, sz2 As Int32, sz3 As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_dbl_3dj",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngDbl3dj(ptr As IntPtr, sz1 As Int32, sz2 As Int32, sz3 As Int32) As Int32
   End Function

   'String   ------------------------------------------------------------------------
   <DllImport(DllName, EntryPoint:="create_rng_str",
           CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngStr(sz As Int32) As IntPtr
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_str",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngStr(buff As IntPtr, sz As Int32) As Int32
   End Function
   <DllImport(DllName, EntryPoint:="fill_rng_str_list",
              CallingConvention:=CallingConvention.StdCall)>
   Friend Function FillRngStrList(buff As IntPtr, sz As Int32, szx() As Int32) As Int32
   End Function
   <DllImport(DllName, EntryPoint:="create_rng_str_list",
           CallingConvention:=CallingConvention.StdCall)>
   Friend Function CreateRngStrList(sz As Int32, _min As Int32, _max As Int32, szx() As Int32) As IntPtr
   End Function

   'C++ Dispose aller allozierten Puffer   ------------------------------------------
   <DllImport(DllName, EntryPoint:="dispose_buffer",
           CallingConvention:=CallingConvention.StdCall)>
   Friend Sub DisposePassing()
   End Sub
End Module
